/*
 * QDS - Quick Data Signalling Library
 * Copyright (C) 2002-2016 Devexperts LLC
 *
 * This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
 * If a copy of the MPL was not distributed with this file, You can obtain one at
 * http://mozilla.org/MPL/2.0/.
 */
package com.dxfeed.event.market.impl;

import com.devexperts.qd.DataRecord;
import com.devexperts.qd.ng.RecordCursor;
import com.devexperts.qd.util.Decimal;
import com.devexperts.qd.util.MappingUtil;
import com.devexperts.util.TimeUtil;

public final class BookMapping extends MarketEventMapping {
// BEGIN: CODE AUTOMATICALLY GENERATED: DO NOT MODIFY. IT IS REGENERATED BY com.dxfeed.api.codegen.ImplCodeGen
	private final int iId;
	private final int iTime;
	private final int iType;
	private final int iPrice;
	private final int iSize;
	private final int iTimeInForce;
	private final int oSymbol;

	public BookMapping(DataRecord record) {
		super(record);
		iId = MappingUtil.findIntField(record, "ID", true);
		iTime = MappingUtil.findIntField(record, "Time", true);
		iType = MappingUtil.findIntField(record, "Type", true);
		iPrice = MappingUtil.findIntField(record, "Price", true);
		iSize = MappingUtil.findIntField(record, "Size", true);
		iTimeInForce = MappingUtil.findIntField(record, "TimeInForce", true);
		oSymbol = MappingUtil.findObjField(record, "Symbol", true);
		putNonDefaultPropertyName("ID", "Id");
	}

	@Deprecated
	public int getID(RecordCursor cursor) {
		return getInt(cursor, iId);
	}

	@Deprecated
	public void setID(RecordCursor cursor, int _ID) {
		setInt(cursor, iId, _ID);
	}

	public int getId(RecordCursor cursor) {
		return getInt(cursor, iId);
	}

	public void setId(RecordCursor cursor, int id) {
		setInt(cursor, iId, id);
	}

	public long getTimeMillis(RecordCursor cursor) {
		return getInt(cursor, iTime) * 1000L;
	}

	public void setTimeMillis(RecordCursor cursor, long time) {
		setInt(cursor, iTime, TimeUtil.getSecondsFromTime(time));
	}

	public int getTimeSeconds(RecordCursor cursor) {
		return getInt(cursor, iTime);
	}

	public void setTimeSeconds(RecordCursor cursor, int time) {
		setInt(cursor, iTime, time);
	}

	public char getType(RecordCursor cursor) {
		return (char)getInt(cursor, iType);
	}

	public void setType(RecordCursor cursor, char type) {
		setInt(cursor, iType, type);
	}

	public double getPrice(RecordCursor cursor) {
		return Decimal.toDouble(getInt(cursor, iPrice));
	}

	public void setPrice(RecordCursor cursor, double price) {
		setInt(cursor, iPrice, Decimal.compose(price));
	}

	public int getPriceDecimal(RecordCursor cursor) {
		return getInt(cursor, iPrice);
	}

	public void setPriceDecimal(RecordCursor cursor, int price) {
		setInt(cursor, iPrice, price);
	}

	public int getSize(RecordCursor cursor) {
		return getInt(cursor, iSize);
	}

	public void setSize(RecordCursor cursor, int size) {
		setInt(cursor, iSize, size);
	}

	public char getTimeInForce(RecordCursor cursor) {
		return (char)getInt(cursor, iTimeInForce);
	}

	public void setTimeInForce(RecordCursor cursor, char timeInForce) {
		setInt(cursor, iTimeInForce, timeInForce);
	}

	public String getSymbol(RecordCursor cursor) {
		return (String)getObj(cursor, oSymbol);
	}

	public void setSymbol(RecordCursor cursor, String symbol) {
		setObj(cursor, oSymbol, symbol);
	}
// END: CODE AUTOMATICALLY GENERATED
}
